*   The Untouchables       launcher  - multipart
*   HAGA    version 



* This must work on TT, Falcon with 2MB RAM
*  with  68030 PMMU swap 

* This may serve as TEMPLATE for :
* 512KB or 1MB games, TOS killing ones - so not using TOS (calls)
* where is further disk access after start
* called multipart
* Loading from floppy is with custom code and direct FDC access





* HAGA function offsets - always 2x function #

*  detHW -  0
*  showHW - 2
*  pmmuSet -4
*  setSHW   - 6    user settings for MSTE, Falcon, TT as cache etc.
*  fileRW    - 8   
*  exitToD    - 10
*  stateSave  - 12
*  restoreState  - 14 
*  commentShow  -  16
*  commentEdit   -  18
* Above 2 only from statesave files
*  loadGos4  -  20
*  loadGos5  -  22
* Above may be used from here for smooth load
* but in this is disabled




* typical call : 
*   	lea	hagaLD(pc),a1
*	move.w	2(a1),d1    *  showHW call
*	jsr	0(a1,d1.w)



******************************************
* Game specific constants, locations :


gIkbdSet	equ	$01140000    *   joy.     mode
* first byte is count (max 3), then IKBD command, params
* For mouse mode enter above $01080000
* If game has mouse and joystick mode selectable enter: $01920000 - query mode



* By some games there is extra option for TT slowdown setting
* what is not needed in most of games



 * Enter here actual length of file:

initClen	equ	0    * Init code len + may contain  title pic (packed)  
* Must be even - so add 1 if odd !


gamFileSize	equ	360448   * For loading after start - size of first image
imagName	equ	"UD1"*256

* label   gamex  -  set keys for DeskEx and StateSave etc .


* At bottom need to edit by need txt messages for DeskEx, Gamex keys
* then Cheat message(s)
* and  Photochrome/HST pic filename


* Conditional assembly variables :

* Use IFNE for cond. met=1 , and IFEQ for not met=0  !


ram1m    equ      0    * 1  if game needs 1MB RAM, otherwise 0 - for 512K

titPic     equ    0   * If there is title pic shown before game start, otherwise 0 


******************************************

beginL        *Beginning of program



* First load HAGA in free RAM and call HW detect :


* Normally load from shared DIR, but first look in current DIR ! :
* With this can have special HAGA for game needing something extra

	
	clr.w	-(a7)
	pea	hagln(pc)
	move.w	#$3D,-(a7)
	trap	#1
	addq.l	#8,a7
	move.w	d0,d7
	bpl.s	loadHagab

* If no - Load from common DIR C:\GAMEX :
	
	
	clr.w	-(a7)
	pea	chagln(pc)
	move.w	#$3D,-(a7)
	trap	#1
	addq.l	#8,a7
	move.w	d0,d7
	bmi	exitu
		
loadHagab	pea	hagaLD
	pea	14000    *  May grove in future !
	move.w	d7,-(a7)
	move.w	#$3F,-(a7)
	trap	#1
	lea	12(sp),sp

	move.w	d7,-(a7)
	move.w	#$3E,-(a7)
	trap	#1
*	addq.l	#4,a7



	lea	hwpal-4,sp    * safe place for stack

* Going supervisor :

	clr.l	-(sp)
	move.w	#32,-(sp)
	trap	#1



	





* Call HWtest, with initial settings :
* Here may test version and abort if not good
* Version is at pos 254:  byte V Major, byte V minor  .

	
	lea	inHWsets(pc),a0
	moveq	#0,d0
	lea	hagaLD,a1
	move.w	(a1),d1
	jsr	0(a1,d1.w)

* Struct :

* 0 -  TOS v major
* 1 - TOS v minor
* 2 - RAMsize in 512KB steps
* 3 -  HW (1-ST, 2-STE,3-MSTE,4-Falcon,5-TT)
* 4 - MSTE clock at start
* 5 -  MSTE clock set
* 6 -  Lang code
* 7 - Real RAM size    (again 512KB step)
* 8 - 68030 flag
* 9 - falccach1
* 10 - falccach2    (11 bytes so far)

* Need some hard disk infos too !  - using PUN and XBRA .

* 11- punDesc for current drive - should describe IF type !

*  00-$07    ACSI  
*  08-$0F     SCSI
*  $10-$11   IDE

* 12 - XBRA param, should be flag for smooth load available - only with PP later drivers
* call checked for presence of D15 file too .

* 13 - Smooth enabled - must set for each game, later ...

* a0 returned points to struct begin !


* If not enough RAM abort :

	move.b	7(a0),d4

  IFEQ  ram1m
	cmp.b	#2,d4
  ENDC

  IFNE  ram1m
	cmp.b	#4,d4
  ENDC

	bcs	noEnoR



* Copy some params for later usage :

	move.b	8(a0),falcfl     * this is actually 68030 flag
	move.b	d4,physRam    * phys RAM amount in 512KB steps
	move.b	3(a0),machin+3   * machine code


* Here may perform low RAM usage test and abort :

* Calc total RAM usage :

	lea	hagaLD(pc),a1   * this is low RAM usage in fact
* with some overshot

	add.l	#$8000,a1   * HAGA space

* Add GOS len - 91 KB if used ....
*  here not

* 1MB RAM case :

	cmp.b	#2,d4
	bne.s	.not1M

	cmp.l	#230000,a1
	bcc	.to

.not1M	
	cmp.b	#4,d4
	bne.s	.not2M

* Here we have max 2x512K for TOS save and SwapSpace !
* What means that by 2MB games used space must be less !

	cmp.l	#400000,a1
	bcc	.to

.not2M
	cmp.l	#1370000,a1   * may be less if large image - well, here no image

.to	bcc	tooMLR


* Game specific :
* IKBD mode settings for restore :

ikbdMode		move.l	#gIkbdSet,50(a0)   * Joy  mode

* first byte is count (max 3), then IKBD command, params
* Or maybe if first is negative then other 3 bytes are 24 bit addres
* with longer ....  later

* SaveLen :

    IFEQ  ram1m
	move.l	#$7FFF8,54(a0)
    ENDC

    IFNE  ram1m
	move.l	#$FFFF8,54(a0)
    ENDC




* Set screen to $1F8000 , ST low :
* or $78000 if only 2 or 1MB

	dc.w 	$A00A       * Hide mouse

InitScrB	equ	$1F8000  * for 4MB min

   IFEQ  ram1m
InitScrB1M	equ	$78000
   ENDC

   IFNE  ram1m
InitScrB1M	equ	$F8000
   ENDC

	lea	InitScrB,a1
	cmp.b	#8,physRam
	bcc.s	min2mp
	lea	InitScrB1M,a1
min2mp
	move.l	a1,screnb   *screen pos. for pic show
	
	clr.w 	-(sp)   *set low res
	pea 	(a1)
	pea	(a1)
 	move.w	#5,-(sp)
	trap	#14
	lea	12(sp),sp





* Set some colors:

	pea	hwpal(pc)
	move.w #6,-(sp)
	trap  #14
	addq.l	#6,sp
	
	move.w  #37,-(sp)
	trap  #14
	addq.l  #2,sp







* Move HAGA in high RAM :

hagaHP4	equ	$3F8000    * 
hagaHP2	equ	$1F8000    * 32K for Haga and below a lot for TOS save
hagaHP1	equ	$F8000  
* TOS save goes in case of 68030 , 4MB min :  area 2MB-3MB 
* If longer than 1MB part remains on loc at 1MB.  Game should
* not write there !  So, with 4MB max occupied RAM is some 1.8 MB 
* on 68030 machines !
* PMMU swap is with 1MB blocks - 0-$100000  and  $200000-$300000

* If TT with 2 MB then TOS goes to area 1MB-1.5MB
* max RAM occupied about 420KB . Good for Hddriver with 10,10,100 settings.
* and Fast RAM (+64KB usage) .
* PMMU swap is with 512KB blocks - 0-$80000  and  $100000-$180000

* On ST(E) TosSave goes always right below HAGA.
* Below TosSave goes GOS, if installed
* or slowSWshift space - same len as TosSave - if more than 1MB RAM .
* for faster swapping.
* Below it is free Workspace

* On ST(E) with only 1MB no SlowSWshift space, using 3 step swap
* Still, 200KB of RAM may remain free, with GOS installed
* Actually, it is possible to have SlowSWshift too, if not too much
* low RAM is occupied ....  maybe later ....





  * up to $C0000, where TOS save space is
* what may be therefore max 256KB - enough for TOS 2.06 ($18872) +
* not too economic hard disk driver - max some 160 KB total usage from ...


	lea	hagaHP4,a1
	cmp.b	#4,physRam
	bcs.s	only1M1
	cmp.b	#8,physRam
	bcc.s	toStoHfp
	lea	hagaHP2,a1
	bra.s	toStoHfp
only1M1	lea	hagaHP1,a1
toStoHfp
	move.l	a1,hagaFp

	lea	hagaLD,a0
	move.w	#3400,d1
.hu	move.l	(a0)+,(a1)+
	dbf	d1,.hu





*


	bsr	clearkb 


	move.w	#34,-(sp)   *  Kbdvbase
	trap	#14
	addq.l	#2,sp

	move.l	d0,a1
	lea	32(a1),a1   * Statvec
	move.l	a1,backSv+2

	move.l	(a1),statVec+2
	move.l	#mySv,(a1)



repSh	move.w  #37,-(sp)
	trap  #14
	addq.l  #2,sp

	
tomap	move.l	hagaFp(pc),a1
	move.w	2(a1),d1
	jsr	0(a1,d1.w)    *HW detected show




	lea   	gamext(pc),a0
	bsr  	pmess


*CheatOpts	
	lea	cheatt(pc),a0
	bsr	pmess



*	cmp.b	#5,machin+3
*	bne.s	disSlow

*	pea	ttSpeedT(pc)
*	move.w	#9,-(sp)
*	trap	#1
*	addq.l	#6,sp

*	bra.s	litPau

disSlow	*move.w	#$6000+noSLd-onlyTT-2,onlyTT

litPau



*Little pause to see it:
	move.w	#1177,d7

dell1	move.w  #37,-(sp)
	trap  #14
	addq.l  #2,sp

* Allow abort with keypress:
	pea	$600ff
	trap	#1
	addq.l	#4,sp 
	tst.b	d0
	beq.s	wait_k


*	cmp.b	#"3",d0
*	blt.s	seeMk

*	cmp.b	#"9",d0
*	bgt.s	seeMk

*	move.b	d0,ttSpeedT+11
*	bra.s	repSh
	
*seeMk

	
	cmp.b	#"M",d0
	beq	megastes
	cmp.b	#"m",d0
	beq	megastes

	cmp.b	#"H",d0
	beq.s	set_inf
	cmp.b	#"h",d0
	beq.s	set_inf 
	
*	cmp.b	#"I",d0
*	beq.s	set_infa
*	cmp.b	#"i",d0
*	beq.s	set_infa

*	cmp.b	#"B",d0
*	beq.s	set_infb
*	cmp.b	#"b",d0
*	beq.s	set_infb

*	cmp.b	#"S",d0
*	beq.s	swaj
*	cmp.b	#"s",d0
*	beq.s	swaj

		
	bra.s	toPicsh

wait_k	dbf	d7,dell1
	bra.s	toPicsh

	
set_inf	st	unlf
*	bra.s	toPicsh

*set_infb	st	unlf

*set_infa	st	unlf+1
	

toPicsh
	
*	moveq	#0,d0
*	move.b	ttSpeedT+11(pc),d0
*	sub.b	#"0",d0
*	move.l	#108000,d1    * Game depending !
*	divu	d0,d1
*	move.w	d1,slowF+2





* Need to wait release of pressed key 


	bsr.s	waitRel


  	move.l	hagaFp(pc),a2
	move.b	$80(a2),d2   * TOS v major
	cmp.b   	#3,d2
	bne.s	seeFalc    * picshow on TT ?
ntR	bsr	ttShow
	bra.s      	loadg   * 

*swaj	st	unlf+2
*	bra	litpau


megastes	* Call HAGA function :


	move.l	hagaFp(pc),a1
	move.w	6(a1),d1    * User settings call
	jsr	0(a1,d1.w)

	bra	tomap


* Wait key release - otherwise repeating by DeskEx :

waitRel	

	tst.b	relFlag
	bne.s	waitRel
	rts



mySv

	

statVec	jsr	0   *

* Need d0  negative , as release signal

	tst.b	d0
	bmi.s 	released
	
	st	relFlag  * Key pressed flag
	rts


released	clr.b	relFlag
	rts

backSv	
	lea	0,a1   *
	move.l	statVec+2(pc),(a1)
	rts

relFlag	dc.b	0,0







seeFalc
 	cmp.b   #4,d2
	bne.s	steph   *to ST(E) show

* Falcon Pic show: 

	jsr    falcpic 
	bra.s      loadg

steph         jsr    photoc    *Call Photochrome pic show rut., on (M)ST(E)

loadg	bsr.s	waitRel

                bsr.s	backSv   *








* Set path to subDIR "FILES" :


	pea	subdif(pc)
	move.w	#59,-(sp)
	trap	#1
	addq.l	#6,sp



cachFs	equ	gamFileSize   *   



	moveq	#0,d0      * 
	clr.b	d2    * no smooth  


   IFEQ  ram1m
	lea	$80000,a3    * RAM used by game - for 512KB
   ENDC

   IFNE  ram1m
	lea	$100000,a3    * RAM used by game - for 1M
    ENDC


	lea	hwpal(pc),a4

	lea	cachFs,a0 
*	move.l	#launLen,d7
	moveq	#0,d7


	move.l	hagaFp(pc),a1   * High RAM 
	move.w	26(a1),d1     * RAMconfig call
	jsr	0(a1,d1.w)



* here need to fill/correct cache params after HAGA call 

	move.l	(a0)+,cachPos
	move.l	(a0)+,cachSiz
	move.w	(a0)+,fullDat





*	lea	$78000,sp





launLen	equ   initClen	*  



   IFNE   initClen


* Loading packed main file :

	clr.w	-(a7)
	pea	inn(pc)
	move.w	#$3D,-(a7)
	trap	#1
	addq.l	#8,a7
	move.w	d0,d7
	bmi	exitu


	move.l	cachPos(pc),-(sp)
	pea	initClen     *  initlen
	move.w	d7,-(a7)
	move.w	#$3F,-(a7)
	trap	#1
	lea	12(sp),sp

	move.w	d7,-(a7)
	move.w	#$3E,-(a7)
	trap	#1
	addq.l	#4,a7

   ENDC







* PMMU settings call :

* of course only if there is 68030 - ....

	move.l	hagaFp(pc),a1   * High RAM 
	moveq	#0,d0    * Default settings  - Must set for future v.
	move.w	4(a1),d1
	jsr	0(a1,d1.w)




*	bsr	clearkb





* Flush IKBD ACIA buffer - may be blocked
aciafl1        btst    #0,$FFFFFC00.w 
	beq.s    aciaempt1
	tst.b     $FFFFFC02.w
	bra.s     aciafl1
aciaempt1  



	
* Here starts actual game launch :

lau_2	

	move.w   #$2700,sr

* Screen to $78000 or $F8000 : - game specific 



   IFEQ    ram1m
	move.b	#$7,$FFFF8201.w
   ENDC

   IFNE   ram1m
	move.b	#$F,$FFFF8201.w
   ENDC

	move.b	#$80,$FFFF8203.w


	move.b	#$13,$FFFFFC02.w   * prevent IKBD overflow

* Comment out above if no key response after start - what means that no IKBD chip set command given by game




* Set SPs for case, safe area  :
* What is best under TOS save
* or under GOS5.2
* in this case may be cachepos+cachesiz or initcLen

	move.l	cachPos(pc),a1
*	add.l	#initClen,a1    
	add.l	cachSiz(pc),a1   * 


	lea	512(a1),a1


	move.l	a1,a7
	move.l	a1,usp



	


supg
*Move following part up - in safe area
	lea	4(a7),a2
 	lea  coup(pc),a1


over1Mu	move.l  a2,a3
	move.w #479,d2
.mo	move.l  (a1)+,(a2)+
	dbf  d2,.mo


* Clear unused IE, IM bits, IS, IP regs recorded
* and Timer C too :

	lea	$FFFFFA07.w,a1   * at IEA reg 
	and.b	#$A1,(a1)
	addq.l	#2,a1
	and.b	#$48,(a1)
	addq.l	#2,a1
	clr.b	(a1)
	addq.l	#2,a1
	clr.b	(a1)
	addq.l	#2,a1
	clr.b	(a1)
	addq.l	#2,a1
	clr.b	(a1)
	addq.l	#2,a1
	and.b	#$A1,(a1)
	addq.l	#2,a1
	and.b	#$48,(a1)

* Above is needed to prevent possible MFP problems, which result often in loosing controls
* It disables all not used interrupts - so serial too - if it is needed must correct !





	jmp  	(a3)





coup  *Must be PC relative !

 

rungame	*

*Must be PC relative !


	lea	$80000,sp


* Clear low RAM : some game may need it

*	lea	$800.w,a1
*	moveq	#0,d1
*	move.w	#$A5F5,d2
*.cll	move.l	d1,(a1)+
*	move.l	d1,(a1)+
*	dbf	d2,.cll



* Depack title pic   -  optional, if there is such - here for NEO format 

  IFNE  titPic

	move.l	cachPos(pc),a1
	add.l	#268872,a1   * position in init file +32 bytes C3 header

   IFEQ  ram1m
	lea	$77F80,a4    * This is for pic in NEO format, where 128 byte header - for PI1 is diff !!!
   ENDC

   IFNE  ram1m
	lea	$F7F80,a4
   ENDC

	bsr	depak3

* Set palette 

   IFEQ  ram1m
	lea	$77F84,a0
   ENDC


   IFNE  ram1m
	lea	$F7F84,a0
   ENDC

	lea	$FFFF8240.w,a1
	moveq	#15,d1
.sp	move.w	(a0)+,(a1)+
	dbf	d1,.sp

   ENDC









ramdPos	equ	$AA0      *  Must find free area in RAM where place our extra code -
* in case of singleparted we need only keyboard test and statesave control


	lea	ramdc(pc),a1
	lea	ramdPos,a2
	move.w	#149,d2     * 
co2l	move.l	(a1)+,(a2)+
	dbf	d2,co2l



* Load init launch :

	lea	$70300,a0
	moveq	#3,d0    * Count
	moveq	#2,d1   * SS
	moveq	#0,d2   * Track

	jsr	ramdPos


* Fix - prevent Vfreq write:

	move.w	#$600A,$70310


* Redirect to our disk access code
	lea	$70504,a1
	move.w	#$4EF8,(a1)+
	move.w	#ramdpos,(a1)


* Set link1 :

	lea	li1(pc),a0
	move.l	a0,$7039A

* Protection check off - inefficient, btw. here

	move.w	#$4E75,$7053E

	move.w	#$4E75,$7048C   * flo access off
	move.w	#$4E75,$704BA

	jmp	$70300



li1	
* Redirect to our disk access code :
	lea	$5B20A,a1
	move.w	#$4EF8,(a1)+
	move.w	#ramdpos,(a1)


	move.w	#$4E75,$5B1C0   * PSG flo set off

* Flo test/change links:

	lea	$5A9A6,a1    *  location in game code - find it with Steem Debugger !!!
	move.w	#$4EB8,(a1)+
	move.w	#ramdPos+floCh1-ramdc,(a1)+
	move.l	#$6000FEAA,(a1)   


	lea	$5AA00,a1    *  location in game code - find it with Steem Debugger !!!
	move.w	#$4EB8,(a1)+
	move.w	#ramdPos+floCh1-ramdc,(a1)+
	move.w	#$602E,(a1)    


	lea	$5ABF8,a1    *  location in game code - find it with Steem Debugger !!!
	move.w	#$4EB8,(a1)+
	move.w	#ramdPos+floCh2-ramdc,(a1)+
	move.w	#$602E,(a1)    


	lea	$5ADB6,a1    *  location in game code - find it with Steem Debugger !!!
	move.w	#$4EB8,(a1)+
	move.w	#ramdPos+floCh2-ramdc,(a1)+
	move.w	#$602E,(a1)    

	lea	$5AF3C,a1    *  location in game code - find it with Steem Debugger !!!
	move.w	#$4EB8,(a1)+
	move.w	#ramdPos+floCh3-ramdc,(a1)+
	move.w	#$602E,(a1)    






	jmp	$58010












machin	ds.b 10

physRam	dc.w	0

falcfl	dc.w    0








ramdc   * 


 *  from  :   first: 


* params :  a0 - dest, d2 - track, d1 - start sector (at 1), d0 - count 

  
*	movem.l	d1-d7/a0-a6,-(sp)

     
	mulu  	 #$1400,d2
	move.l	d2,d4
	
	ext.l	d1
	subq.w	#1,d1
	lsl.w   	#5,d1
	lsl.l	#4,d1
	add.l	d1,d4
	
	ext.l	d0
	lsl.w   	#5,d0
	lsl.l	#4,d0

	move.l	d0,d3
	add.l	d4,d3
	
	move.l	a0,a3
	
entr1
	lea	cacheS(pc),a2


noFch
	tst.l	(a2)  * Data in ?
	bmi	readAhe


* Is requested data in cache ?

	cmp.l	(a2),d4
	blt	readAhe
	cmp.l	cacheE-cacheS(a2),d4
	bge	readAhe

* Whole requested size ?
* Condition:  cache size must be at least as size of longest file !

	cmp.l	cacheE-cacheS(a2),d3
	bgt	readAhe

	sub.l	d4,d3
	sub.l	(a2),d4

copDfc	*move.l	d3,d0    * ret param  ?
	move.l	d4,a1
	add.l	cachPos(pc),a1

.coc	move.b	(a1)+,(a3)+
	subq.l	#1,d3
	bne.s	.coc

* Ret to game :

retToG	
	

*	movem.l	(sp)+,d1-d7/a0-a6
*	moveq	#0,d0


* Need to insert here gamex links, for each level separately :


* Gamex :
* Need to find game's IKBD code, part which process keyboard press
	
	move.w	#$08B8,d1


* For stage 1  :

	lea	$658B2,a1    *  location in game code - find it with Steem Debugger !!!
	cmp.w	(a1),d1
	beq	wriGx

	
* For stage 2  :

	lea	$6521C,a1    *  location in game code - find it with Steem Debugger !!!
	cmp.w	(a1),d1
	beq	wriGx


	
* For stage 3  :

	lea	$658BC,a1    *  location in game code - find it with Steem Debugger !!!
	cmp.w	(a1),d1
	beq.s	wriGx

	
* For stage 4  :

	lea	$65FB0,a1    *  location in game code - find it with Steem Debugger !!!
	cmp.w	(a1),d1
	beq.s	wriGx



* Stage 6 - roof :



	lea	$679C8,a1    *  location in game code - find it with Steem Debugger !!!
* Use location with :  bclr #6,$FFFFFA11.w - so can have same code for all levels

	cmp.w	(a1),d1
	bne.s	nlev6


	move.b	unlf(pc),d2
	beq.s	wriGx
	
	move.w	#$6002,$65684   * Time
	move.b	#$4A,$65952   * Health
	
	bra.s	wriGx

nlev6	rts

wriGx	move.w	#$4EF8,(a1)+
	move.w	#ramdPos+gamex-ramdc,(a1)
	rts





readAhe		sub.l	d4,d3
	lea	parlist(pc),a0
	move.l	rdn(pc),14(a0)


	move.b	fullDat(pc),d1
	beq.s	notFulC

* Load whole file :

	clr.l	(a2)
	move.l	maxDat(pc),cacheE-cacheS(a2)

	move.l	cachPos(pc),(a0)
	clr.l	4(a0)
	move.l	maxDat(pc),8(a0)

	move.l	hagaFp(pc),a1
	move.w	8(a1),d1
	jsr	0(a1,d1.w)

*	moveq	#0,d4

	bra.s	toCo


notFulC
	move.l	d4,4(a0)   * offset
	move.l	d4,(a2)

* always load 200000 as cache size here (or what is given) 
	
	move.l	cachSiz(pc),8(a0)



* Using size of cache, but if data ends before, then shorter
* not wise !
* if data ends before, set pos lower, so end will reach right
* cache end

* then need to correct  d4, as pos marker for that diff !!!!

	move.l	d4,d2
	add.l	cachSiz(pc),d2
	cmp.l	maxDat(pc),d2
	ble.s	notOvc

	move.l	maxDat(pc),d2
	move.l	d2,d0
	sub.l	cachSiz(pc),d0   * this is new cache ofs.

	move.l	d0,4(a0)   * offset
	move.l	d0,(a2)

	sub.l	d0,d4   * offset for current file
	bra.s	ovcE

notOvc	

	moveq	#0,d4

ovcE	move.l	d2,cacheE-cacheS(a2)
	move.l	cachPos(pc),(a0)

	move.l	hagaFp(pc),a1
	move.w	8(a1),d1
	jsr	0(a1,d1.w)

* d3 should be unchanged 


toCo	bra	copDfc
	





floCh1    * change to floppy 1 - from $5AA

	moveq	#"1",d0
	move.l	#360448,d2
	bra.s	floCc

floCh2	moveq	#"2",d0    * from  
	move.l	#409600,d2
	bra.s	floCc

floCh3	moveq	#"3",d0    * from 
	move.l	#274944,d2

floCc	move.b	rdn+2(pc),d1   * current inserted
	cmp.b	d0,d1
	beq.s	noFlc


	lea	rdn+2(pc),a1
	move.b	d0,(a1)

	move.l	#-1,caches-rdn-2(a1)   * force load

* Correct maxdat - image size

	move.l	d2,maxdat-rdn-2(a1)

noFlc	rts


	


unlf	dc.w	0,0    *  Here keep user settings for desired cheats







* Usually only 3 chars, so may :

rdn    	dc.l  	imagName     *  

	even






* Following block is here only for compatibility reasons
* Only used parameter is cachPos

cacheS	dc.l	$FFFFFFFF     * data in index
cacheE	dc.l	0      *  next after end  (+1)
maxDat	dc.l	gamFileSize   * in fact file size




* Following is just initial value, depends from used RAM, machine type
* On TT, Falcon cache pos must be different !  :

   IFEQ  ram1m
cachPos	dc.l	$81000
   ENDC

   IFNE  ram1m
cachPos	dc.l	$101000
    ENDC

cachSiz	dc.l	200000   * for 1MB only machines
fullDat	dc.w	1    * if not 0 then load whole file





* Desktop exit key watch :


* Jumped from   from 



gamex	 * from - each level has own code, so diverse - use jsr 
	

	cmp.b   #$E5,d0   * For / released
	beq.s    gamex_w
	cmp.b   #$E6,d0   * For * on NumPad released
	beq.s    toDeskEx

* Not always d0 is where pressed key code is readen by game - so correct by need


  
gamnoex 
	bclr	#6,$FFFFFA11.w
	move.l	(sp)+,a0
	move.w	(sp)+,d0
	rte


toDeskEx	   *  go via pos save code, with d0=55
	
	movem.l	d0-d7/a0-a6,-(sp)
	moveq	#55,d0
	bra.s	gexCom


backingam	movem.l	a0-a1,-(sp)
	move.l	cachPos(pc),a0
	subq.l	#8,a0
	cmp.l	#"cVal",(a0)+
	bne.s	notAst
	lea	cacheS(pc),a1
	move.l	(a0),(a1)

notAst	
	movem.l	(sp)+,a0-a1
	bra.s	gamnoex






*Save state  



	
gamex_w   *Exiting game with storing state 

* Code for game state store when exit is requested:




GameSto    * The code itself. Must be PC relative !!!

* Presumable we are in supervisor mode....
* For games not running in SV need some switch, workaround...
* will see later....


* 	0	USP
*  	4	Cur screen resolution - almost always 0 !
*	6	SSP
*	10	Palette, 32 bytes
*	42	MFP state, 24 bytes
*	66	Screen base
*	70	IKBD joy status, 8 bytes
*	80	SR,  2 bytes
* 	84	PSG status, 14 bytes
*	100	IKBD mouse status, 8 bytes
*	108	STE DMA , 8 bytes



ikbdof	  equ	70
ikbdm_of    equ      100
srofs	  equ	80
psgofs       equ	84
stedmaof    equ      108	

* Store CPU regs, SR, stack pointers
	
*	move.l	sp,$600.w    * Little help for crash catch - may need to comment out if conflicts !
	movem.l	d0-d7/a0-a6,-(sp)

* Write magic and cache state, to avoid reloading after
* saving state :

	move.l	cachPos(pc),a0
	subq.l	#8,a0
	move.l	#"cVal",(a0)+
	move.l	cacheS(pc),(a0)


	moveq	#0,d0    * Only default ST saves needed
gexCom	lea	GameStat(pc),a0
	move.w	sr,80(a0)
	move.w	#$2700,sr

	lea	cacheS(pc),a2
	move.l	#-1,(a2)    * Cache empty flag


* Continuing in HAGA function :

* Needed parameters:

* backingam adress, GameStat address ... ?

	lea	backingam(pc),a2

	move.l	hagaFp(pc),a1   
	move.w	12(a1),d1
	jsr	0(a1,d1.w)




hagaFp	dc.l	0  ***
* Must right after HAGA func call, with jsr
* so will have hagaFp var loc ! This helps in running snap on diff
* RAM size !

parlist	ds.b     28   * if no place here, may in high RAM too !



* Simple, short, but fast depacker :

depak3	clr.l d0
	moveq    #6,d4
	moveq    #$3f,d5   *for masking bits 5-0

* Bit meaning:  7 - if set it's back referrer , if 0 then bits
* 6-0 give count of literals to copy
* if all bits are 0 it is terminator

* When bit 7 set, bit 6: if 1 then long distance back given by 2 following byte
*  bit 6: when 0  then short distance given by following 1 byte
*  bits 5-0  count of bytes referred. 
*  By short refer.  0 means 3, 1 means 4, etc  up to 66 .
*  By long refer.  0 means 4, 1 means 5, etc  up to 67 .


main3 	clr.w d0 *prep for dbf
	move.b (a1)+,d0
	bmi.s back3 
	beq.s nom3 *end
	subq.w #1,d0 *compens dbf
litc 	move.b (a1)+,(a4)+
	dbf d0,litc
	bra.s main3

nom3	rts

back3	move.b d0,d2
	and.w d5,d2 *d5=$3f
* Test is long or short referrer:
	btst    d4,d0   *test bit 6
	bne.s  longr
	
	addq.w #2,d2 *compens	
displl	move.b (a1)+,d0 * displac
calcadr	move.l a4,a2
	sub.l d0,a2
baksl	move.b (a2)+,(a4)+
	dbf d2,baksl
	bra.s main3

longr	addq.w #3,d2 *compens
	move.b (a1)+,d0 * displac
	lsl.w  #8,d0   *MSB
	bra.s   displl

* End of C3 depak





* End of code for moving up .


GameStat

* Space at here free by gameplay - when copied in game space






**********************


	








* Settings :
* 0 - MSTE clock  0 or non 0 for 16MHz
* 1 - Falcon bus settings
* 2 - Falcon cache settings, word
* 4 - TT cache settings, word
* 6 - TT bus settings
* 7 - spare

* Initial HW settings, may be changed if press M, and screw it up too :-)
inHWsets  dc.b  0,$45,8,9,8,8,0,0    * 

* above means:
* MSTE 8MHz ;  Falcon 8MHz, STE bus emul ; 
* Falcon cache instr, on, data off ; TT cache instr off, data off ;
* TT bus - default - 24 bit bus emul + swap support with 1MB pages .... (0) 



* File containing whole game code + data, best to pack with C3 packer :

*inn	dc.b	"YOL",0


chagln   	dc.b  	"C:\GAMEX\"
hagln	dc.b	"HAGA",0

subdif	dc.b	"FILES",0
    even




 


pmess      pea  (a0)
	move.w  #9,-(sp)
	trap   #1
	addq.l  #6,sp
	rts


 



clearkb	move.w	#11,-(sp)   *Cconis
	trap	#1
	addq.l	#2,sp
	tst.l	d0
	beq.s	nocha

	move.w	#7,-(sp)   *Crawcin
	trap	#1
	addq.l	#2,sp
	bra.s	clearkb

nocha	rts

    ds.b  512    * stack space

hwpal   *Palette for HW show :
  

   dc.w   $562,$7,$7,$7,$7,$7,$7,$7
   dc.w   $7,$7,$7,$7,$7,$7,$7,7


noEnoR
	lea	noEnrt(pc),a0
	bra.s	exitC

tooMLR	
	lea	tooMLRm(pc),a0
	bra.s	exitC

exitu 
	lea	misFt(pc),a0
exitC	bsr	pmess

* wait keypress :
	move.w	#1,-(sp)
	trap	#1


	clr.w -(sp)
	trap #1

*ttSpeedT  dc.b  13,10,"TT speed=6",0


gamext  dc.b   13,10,13,10,"Exit to Desktop:  * on NumPad",13,10
	dc.b  "Save gamestate:  / on NumPad",27,"H",0


* Optional cheat message:

cheatt      dc.b  27,"H","Press H for help on last stage",0
	





misFt	dc.b   "Some file(s) missing.",13,10
	dc.b  "Please reinstall from ZIP.",0

  IFEQ   ram1m
noEnrt	dc.b  "Min RAM for this is 1MB.",0
  ENDC

  IFNE   ram1m
noEnrt	dc.b  "Min RAM for this is 2MB.",0
  ENDC

tooMLRm	dc.b  "Too much low RAM occupied.",13,10
	dc.b   "Read usage how to fix it.",0



    even





screnb  ds.l    1




photoc

* Flexible overscan - up to 273 lines



* 320x228-273   overscan 


lines	equ	240    * Vertical res.  Write here for particular title !
ovsDel	equ	173   * For 240 lines

* Formula for calculating ovsDel :  

* (273 - verticalRes) x 64 /26.04 + 92 

	
   include  "OVSSH.S"    *  For over 228  lines OVS





  section data

* Correct filenames by need  :

picfn	dc.b	"FUN240.HST",0
ttfPic	dc.b	"UN240D.BMP",0
  even



  section  bss

palsav	ds.b  32
 
   ds.b  512    * stack space

hagaLD   

head   ds.b  6   *PCH header here...
stbitm  ds.b  32000
stpal    ds.b  $4B20
stbm2    ds.b 32000 
stpal2    ds.b  $4B20
convtbl  ds.b  8192










